
#include <string>
#include <vector>
#include <iostream>
#include <string.h>
#include <stdio.h>
#include "types.H"
#include "midiplayer.H"

// unix specific includes
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>



using namespace std;
using namespace algarrobo;


u8 *midiData;


int main(int argc, char **argv) {
	// load midi file into memory
	if (argc < 2) {
		cerr << "Syntax: " << argv[0] << " midifile" << endl;
		return 1;
	}
	int fd = open(argv[1], O_RDONLY);
	if (fd <= 0) {
		cerr << "Could not load '" << argv[1] << "'" << endl;
		return 1;
	}
	struct stat statBuf;
	fstat(fd, &statBuf);
	cerr << statBuf.st_size << " bytes" << endl;
	midiData = new u8[statBuf.st_size];
	read(fd, midiData, statBuf.st_size);
	// play midi
	TDummyMidiPlayer player;
	TMidiFileParser smf(player);
	smf.load(midiData);
	smf.play();
	bool deltaTimeIntervalChanged = false;
	while (smf.tick(deltaTimeIntervalChanged)) {
		u32 delta = smf.getDeltaTimeIntervalMicroseconds();
		// cout << "delta: " << delta << endl;
		usleep(delta);
	}
	smf.stop();
	// free memory
	delete midiData;
	return 0;
}
