

#ifndef  __MIDIFILEPARSER_H__
#define  __MIDIFILEPARSER_H__


#include <stdlib.h>
#include <stdint.h>
#include "miditrack.h"


typedef struct {
	void (*sendMidiEventCallback)(uint8_t *, uint8_t);
	uint8_t playing;
	uint16_t numTracks;
	uint8_t *midiFile;
	uint16_t format;
	uint16_t division;
	uint32_t deltaTimeIntervalMicroseconds;
	uint32_t currentTempo;                      // microseconds per quarter note
	midiTrack *tracks;
} midiFileParser;


extern void midiFileParserInit(midiFileParser *t, void (*sendMidiEventCallback)(uint8_t *, uint8_t));
extern uint8_t midiFileParserLoad(midiFileParser *t, uint8_t *data);
extern void midiFileParserUpdateDeltaTimeInterval(midiFileParser *t);
extern uint32_t midiFileParserGetDeltaTimeIntervalMicroseconds(midiFileParser *t);
extern void midiFileParserPlay(midiFileParser *t);
extern void midiFileParserStop(midiFileParser *t);
extern uint8_t midiFileParserTick(midiFileParser *t, uint8_t *deltaTimeIntervalChanged);
extern void midiFileParserFreeTracks(midiFileParser *t);
extern void midiFileParserRelease(midiFileParser *t);


#endif  // __MIDIFILEPARSER_H__
