

#ifndef  __MIDITRACK_H__
#define  __MIDITRACK_H__


#include <stdlib.h>
#include <stdint.h>


typedef struct {
	uint8_t *data;
	void (*sendMidiEventCallback)(uint8_t *, uint8_t);
	uint8_t *pointer;
	uint32_t deltaCounter;
	uint8_t runningStatus;
	uint8_t playing;
} midiTrack;


extern void midiTrackInit(midiTrack *t, uint8_t *p, void (*sendMidiEventCallback)(uint8_t *, uint8_t));
extern void midiTrackPlay(midiTrack *t);
extern void midiTrackStop(midiTrack *t);
extern uint32_t getNextValue(midiTrack *t);
extern uint32_t midiTrackGetVarLen(midiTrack *t);
extern uint8_t midiTrackNumDataBytes(uint8_t status);
extern int32_t midiTrackTick(midiTrack *t);


#endif  // __MIDITRACK_H__
